# coding: utf-8

"""
    Orbit Extrapolation API

    Orbit Extrapolation API

    The version of the OpenAPI document: 2.4.3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from spacetower_orbit_extrapolation_python_client.models.anomaly_type import AnomalyType
from spacetower_orbit_extrapolation_python_client.models.covariance_orbit_type import CovarianceOrbitType
from spacetower_orbit_extrapolation_python_client.models.final_covariance_configuration import FinalCovarianceConfiguration
from spacetower_orbit_extrapolation_python_client.models.output_covariance_type import OutputCovarianceType
from typing import Optional, Set
from typing_extensions import Self

class FinalOrbitalElementsCovarianceConfiguration(FinalCovarianceConfiguration):
    """
    Configuration for the output of the final covariance matrix in orbital elements form. The frame type is selected from the OutputConfiguration 
    """ # noqa: E501
    covariance_orbit_type: Optional[CovarianceOrbitType] = Field(default=None, alias="covarianceOrbitType")
    covariance_anomaly_type: Optional[AnomalyType] = Field(default=None, alias="covarianceAnomalyType")
    __properties: ClassVar[List[str]] = ["finalCovarianceType", "covarianceOrbitType", "covarianceAnomalyType"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FinalOrbitalElementsCovarianceConfiguration from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FinalOrbitalElementsCovarianceConfiguration from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "finalCovarianceType": obj.get("finalCovarianceType"),
            "covarianceOrbitType": obj.get("covarianceOrbitType"),
            "covarianceAnomalyType": obj.get("covarianceAnomalyType")
        })
        return _obj


